﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Encodings.BinaryVectorEncoding;

namespace HeuristicLab.Problems.NK {

  public interface IBinaryVectorComparer : INamedItem, IComparer<BinaryVector> { }

  [StorableClass]
  public abstract class BinaryVectorComparer : NamedItem, IBinaryVectorComparer {

    public override bool CanChangeName { get { return false; } }
    public override bool CanChangeDescription { get { return false; } }

    [StorableConstructor]
    protected BinaryVectorComparer(bool serializing) : base(serializing) { }
    protected BinaryVectorComparer(BinaryVectorComparer original, Cloner cloner)
      : base(original, cloner) { }
    public BinaryVectorComparer() {
      name = ItemName;
      description = ItemDescription;
    }    

    public abstract int Compare(BinaryVector x, BinaryVector y);
  }  
}
